/*

<APPLET WIDTH=600 HEIGHT=550 CODE="Cannibal.class"></APPLET>

*/


import java.awt.*;
import java.applet.*;
import java.awt.event.*;

public class Cannibal extends Applet implements ItemListener {

	public static String tempString = new String();

	/*************** view panels ****************/
	public static Panel inputPanel = new Panel();
	public static GraphCanvas graph = new GraphCanvas(596,150);
	public static Panel3D galPanel3D = new Panel3D(false);
	public static Panel3D satPanel3D = new Panel3D(true);
	/********************************************/



	public static int WIDTH = 600;
	public static int HEIGHT = 550;



	/** integration stuff until i organize it better **/

	final double G=4.43e-3;
	double satmass=6e9;
	//double satmass0 = satmass;
	//double sata=500;
	//double diskmass,diska,diskb,halomass,haloa, rhosat, satrad;
	public static double[][] stars, starsC;
	public static double[] w;

	public static int nstars;
	public static boolean STOPFLAG=true, PAUSEFLAG=false;
	public static GalRunner galRunner;
	//public static SatTracker satTracker;
	//public static StarTracker starTracker;





	/************** input controls **************/
	public static Variable rapoInput;
	public static Variable rperiInput;
	public static Variable inclInput;
	public static Choice satmassChoice;
	public static Variable satradInput;
	public static InputSlider timeStepSlider;
	public static Choice nstarsChoice;

	public static Button startButton = new Button("START");
	public static Button stopButton = new Button("STOP");
	public static Button pauseButton = new Button("PAUSE");

	public static Checkbox diskToggle = new Checkbox("Disk Effects",true);
	public static Checkbox mlToggle = new Checkbox("Mass Loss",true);
	public static Checkbox dfToggle = new Checkbox("Dynamic Friction",true);


	//public static InputSlider printStepSlider;

	/********************************************/



	public void start() {
		removeAll();
		setBackground(Color.white);

		/** layout the main panels **/
		setLayout(null);
		add(galPanel3D);
		galPanel3D.setBounds(WIDTH/2+2,2,298,298);

		add(satPanel3D);
		satPanel3D.setBounds(2,2,298,298);

		add(graph);
		graph.setBounds(2,302,WIDTH-4,150);

		add(inputPanel);
		inputPanel.setBounds(2,452,WIDTH-4,150);


		setupInputPanel();


	}


	public void init() {

	}

	public void setupInputPanel() {
		int y=0, x=0, w1=100,w2=120,w3=80,h=20;

		Label satLabel= new Label("Satellite Parameters",Label.CENTER), orbLabel = new Label("Orbit Parameters",Label.CENTER), simLabel = new Label("Sim Parameters",Label.CENTER);

		/** create the input panel **/
		inputPanel.removeAll();
		inputPanel.setLayout(null);

		timeStepSlider = new InputSlider("Timestep (kYr): ",100,0,1000,1);

		rapoInput = new Variable("Apogee Rad (kpc):",50);
		rapoInput.setMinValue(0);

		rperiInput = new Variable("Perigee Rad (kpc):",35);
		rperiInput.setMinValue(0);

		inclInput = new Variable("Inclination (deg):",45);
		inclInput.setMinValue(0);
		inclInput.setMaxValue(90);

		satradInput = new Variable("Satellite Rad (kpc):",0.5);

		nstarsChoice = new Choice();
		nstarsChoice.addItem("0");
		nstarsChoice.addItem("25");
		nstarsChoice.addItem("50");
		nstarsChoice.addItem("100");
		nstarsChoice.addItem("250");
		nstarsChoice.addItem("500");

		satmassChoice = new Choice();
		satmassChoice.addItem("10%");
		satmassChoice.addItem("5%");
		satmassChoice.addItem("1%");


		inputPanel.add(satLabel);
		satLabel.setBounds(5,0,190,20);
		inputPanel.add(orbLabel);
		orbLabel.setBounds(200,0,190,20);
		inputPanel.add(simLabel);
		simLabel.setBounds(400,0,190,20);

		Label satmassLabel = new Label("Satellite Mass:");
		inputPanel.add(satmassLabel);
		satmassLabel.setBounds(5,20,110,20);
		inputPanel.add(satmassChoice);
		satmassChoice.setBounds(115,20,75,20);

		inputPanel.add(satradInput.label);
		satradInput.label.setBounds(5,45,110,20);
		inputPanel.add(satradInput.inputField);
		satradInput.inputField.setBounds(115,45,75,20);

		inputPanel.add(stopButton);
		startButton.setBounds(5,70,60,20);
		inputPanel.add(pauseButton);
		pauseButton.setBounds(70,70,60,20);
		inputPanel.add(startButton);
		stopButton.setBounds(135,70,60,20);

		/***********************************************/

		inputPanel.add(rapoInput.label);
		rapoInput.label.setBounds(200,20,110,20);
		inputPanel.add(rapoInput.inputField);
		rapoInput.inputField.setBounds(310,20,75,20);

		inputPanel.add(rperiInput.label);
		rperiInput.label.setBounds(200,45,110,20);
		inputPanel.add(rperiInput.inputField);
		rperiInput.inputField.setBounds(310,45,75,20);

		inputPanel.add(inclInput.label);
		inclInput.label.setBounds(200,70,110,20);
		inputPanel.add(inclInput.inputField);
		inclInput.inputField.setBounds(310,70,75,20);

		/***********************************************/

		Label nstarsLabel = new Label("# of Stars:");
		inputPanel.add(nstarsLabel);
		nstarsLabel.setBounds(400,20,60,20);
		inputPanel.add(nstarsChoice);
		nstarsChoice.setBounds(490,20,100,20);
		nstarsChoice.addItemListener(this);

		inputPanel.add(timeStepSlider);
		timeStepSlider.setBounds(490,45,50,20);
		inputPanel.add(timeStepSlider.label);
		timeStepSlider.label.setBounds(400,45,150,20);
		inputPanel.add(timeStepSlider.valueLabel);
		timeStepSlider.valueLabel.setBounds(550,45,45,20);
		timeStepSlider.setEnabled(false);

		inputPanel.add(diskToggle);
		diskToggle.setBounds(405,70,90,20);
		inputPanel.add(mlToggle);
		mlToggle.setBounds(505,70,90,20);




		/***********************************************/


		startButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				STOPFLAG = false;

				if(rperiInput.getValue() > rapoInput.getValue()) {
					double temp = rperiInput.getValue();
					rperiInput.setValue(rapoInput.getValue());
					rapoInput.setValue(temp);
				} else if (rperiInput.getValue() == rapoInput.getValue()) {
					rperiInput.setValue(rperiInput.getValue() - .001 * rperiInput.getValue());
				}

				rapoInput.inputField.setEnabled(false);
				rperiInput.inputField.setEnabled(false);
				inclInput.inputField.setEnabled(false);
				satmassChoice.setEnabled(false);
				satradInput.inputField.setEnabled(false);
				nstarsChoice.setEnabled(false);
				startButton.setEnabled(false);


				nstars = Integer.parseInt(nstarsChoice.getSelectedItem());
				stars = new double[nstars][6];
				starsC = new double[nstars][6];

				galRunner = new GalRunner();

				graph.reset();

				galPanel3D.setDataBounds(-50000,50000,-50000,50000);
				satPanel3D.setDataBounds(-10000,10000,-10000,10000);

				Thread galPanel = new Thread(galPanel3D);
				galPanel.setPriority(Thread.MIN_PRIORITY);

				Thread satPanel = new Thread(satPanel3D);
				satPanel.setPriority(Thread.MIN_PRIORITY);

				galPanel.start();
				satPanel.start();

				galRunner.start();
			}
		});

		pauseButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				PAUSEFLAG = !PAUSEFLAG;
				if(PAUSEFLAG == true) {
					pauseButton.setForeground(Color.red);
				} else {
					pauseButton.setForeground(Color.black);
				}
			}
		});


		stopButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				STOPFLAG = true;
				PAUSEFLAG= false;
				pauseButton.setForeground(Color.black);
			}
		});
	}

	public void itemStateChanged(ItemEvent e) {
		if(nstarsChoice.getSelectedIndex() == 0) timeStepSlider.setEnabled(false);
		else timeStepSlider.setEnabled(true);
	}


}
