
import java.awt.*;

public class GraphCanvas extends Canvas{

    final int HEIGHT;
    final int WIDTH;
   /* int x_max;
    int y_max;*/
    int measurements = 10000;
    public int point_index = 0;
  /*  double x_scale;
    double y_scale;
    double y_scale_2;*/


    double[] xpoints;

    double[] ypoints;

    double[] ypoints2;

    float[][] history; // array for t,x,y,z,satmass

    double xDataMin = 0, xDataMax=0, massMax=1.0, radMax=0;

    Image offImage;

    Graphics g;



    GraphCanvas(int w, int h){
	  WIDTH = w;
	  HEIGHT = h;
	  history = new float[5][measurements];

	//  x_max = WIDTH;
	//  y_max = HEIGHT;
	//  setMax(10000, 750);
	  setBackground(Color.black);
    }//constructor

    public void paint(Graphics g){
        update(g);

    }//paint

    public void update(Graphics h){
        offImage = createImage(getSize().width, getSize().height);
        g = offImage.getGraphics();



		Point p1=new Point(), p2=new Point();

		g.setColor(Color.white);
		for(int i=0; i<= WIDTH; i+=.20*WIDTH) {
			g.setColor(Color.white);
			g.drawLine(i,0,i,HEIGHT);
			if(point_index > 5) {
				if(Math.abs(i-WIDTH)<10) {
					g.drawString(FMath.roundOff((i/(double)WIDTH)*history[0][point_index-1]/1000.,2)+"",i-30,HEIGHT-5);
				} else {
					g.drawString(FMath.roundOff((i/(double)WIDTH)*history[0][point_index-1]/1000.,2)+"",i+2,HEIGHT-5);
				}
			}
		}
		g.drawString("Time (GYr)",50,HEIGHT-5);

		for(int i=0; i<= HEIGHT; i+=.20*HEIGHT) {
			g.setColor(Color.white);
			g.drawLine(0,i,WIDTH,i);
			if(point_index > 5) {
				g.setColor(Color.red);
				g.drawString(FMath.roundOff(100-(100*i/((double)HEIGHT)),2)+"",WIDTH-30,i+10);
				g.setColor(Color.yellow);
				g.drawString(FMath.roundOff((1-(i/((double)HEIGHT)))*Cannibal.rapoInput.getValue(),2)+"",5,i+10);
			}
		}

		g.setColor(Color.yellow);

		if(point_index>5) g.drawString("Radius (kpc)=" + FMath.roundOff(FMath.rss(Cannibal.w[0],Cannibal.w[1],Cannibal.w[2])/1000.,3),150,12);

		//Plot Radius
		for(int i=1; i< point_index; i++) {
			p1 = radDataToScreen( history[0][i-1],FMath.rss(history[1][i-1],history[2][i-1],history[3][i-1]) );
			p2 = radDataToScreen( history[0][i],FMath.rss(history[1][i],history[2][i],history[3][i]) );
			g.drawLine(p1.x,p1.y,p2.x,p2.y);
		}
		//if(point_index > 0)	g.drawString(FMath.roundOff(FMath.rss(Cannibal.w[0],Cannibal.w[1],Cannibal.w[2])/1000.,3)+"",p2.x-50,p2.y);


		g.setColor(Color.red);
		if(point_index>5) g.drawString("Mass (% of Initial)=" + FMath.roundOff(100*history[4][point_index-1]/Cannibal.galRunner.satmass0,3),WIDTH-300,12);
		//Plot Mass
		for(int i=1; i< point_index; i++) {
			p1 = massDataToScreen( history[0][i-1],history[4][i-1]/Cannibal.galRunner.satmass0);
			p2 = massDataToScreen( history[0][i],history[4][i]/Cannibal.galRunner.satmass0);
			g.drawLine(p1.x,p1.y,p2.x,p2.y);
		}
		//if(point_index > 0)	g.drawString(FMath.roundOff(100*history[4][point_index-1]/Cannibal.galRunner.satmass0,3)+"",p2.x-50,p2.y);
        h.drawImage(offImage, 0, 0, this);

    }//update


    public void reset(){

	  history = new float[5][measurements];
	  xDataMax = 0;
	  massMax=1.0;
	  radMax=0;

	  point_index = 0;

	  repaint();



    }//reset



    public void setMax(int x_max, int y_max, int y_max2){



	 /* this.x_max = x_max;

	  this.y_max = y_max;

	  x_scale = (double)WIDTH/x_max;

	  y_scale = (double)HEIGHT/y_max;

	  y_scale_2 = y_scale*(200/30);
	  reset();

	  repaint();
*/


    }//setScale



    public void addPoints(double t,double x, double y, double z, double m){
	  if(point_index<measurements){

		  radMax = Math.max(FMath.rss(x,y,z),radMax);
		  xDataMax = Math.max(t,xDataMax);

	      history[0][point_index] = (float)t;
	      history[1][point_index] = (float)x;
	      history[2][point_index] = (float)y;
	      history[3][point_index] = (float)z;
	      history[4][point_index] = (float)m;

	      point_index++;

	      //System.out.println(point_index);

	      repaint();

	  }//if



    }//addPoint


	public Point massDataToScreen(double x, double y) {
		int screenX = 0,screenY = 0; // VALUES TO BE RETURNED
		double deltaX = xDataMax - 0;
		double deltaY = massMax - 0;
		screenX = (int)((WIDTH/deltaX)*(x - 0));
		screenY = (int)((HEIGHT) - ( (HEIGHT/deltaY)*(y - 0)));
		return(new Point(screenX,screenY));
	}

	public Point radDataToScreen(double x, double y) {
		int screenX = 0,screenY = 0; // VALUES TO BE RETURNED
		double deltaX = xDataMax - 0;
		double deltaY = radMax - 0;
		screenX = (int)((WIDTH/deltaX)*(x - 0));
		screenY = (int)((HEIGHT) - ( (HEIGHT/deltaY)*(y - 0)));
		return(new Point(screenX,screenY));
	}



    public Dimension getPreferredSize(){



	  return new Dimension(WIDTH, HEIGHT);



    }//getPreferredSize



}//GraphCanvas





